Eclipse Remote Application Platform

## org.eclipse.swt.custom
Class CCombo

    java.lang.Object
      org.eclipse.swt.widgets.Widget
          org.eclipse.swt.widgets.Control
              org.eclipse.swt.widgets.Scrollable
                  org.eclipse.swt.widgets.Composite
                      org.eclipse.swt.custom.CCombo

All Implemented Interfaces:
  Adaptable, Drawable

    public final class CCombo

extends Composite

The CCombo class represents a selectable user interface object that combines a text field and a list and issues notification when an item is selected from the list.

CCombo was written to work around certain limitations in the native combo box. Specifically, on win32, the height of a CCombo can be set; attempts to set the height of a Combo are ignored. CCombo can be used anywhere that having the increased flexibility is more important than getting native L&F, but the decision should not be taken lightly. There is no is no strict requirement that CCombo look or behave the same as the native combo box.

Note that although this class is a subclass of `Composite`, it does not make sense to add children to it, or set a layout on it.

Styles:
  BORDER, READ_ONLY, FLAT
Events:
  DefaultSelection, Modify, Selection, Verify

Since:
  1.2

Field Summary
`static int` `LIMIT` The maximum number of characters that can be entered into a text widget.

Constructor Summary
`CCombo(Composite parent, int style)` Constructs a new instance of this class given its parent and a style value describing its behavior and appearance.

Method Summary
`void` `add(java.lang.String string)` Adds the argument to the end of the receiver's list.
`void` `add(java.lang.String string, int index)` Adds the argument to the receiver's list at the given zero-relative index.
`void` `addModifyListener(ModifyListener listener)` Adds the listener to the collection of listeners who will be notified when the receiver's text is modified, by sending it one of the messages defined in the `ModifyListener` interface.
`void` `addSelectionListener(SelectionListener listener)` Adds the listener to the collection of listeners who will be notified when the user changes the receiver's selection, by sending it one of the messages defined in the `SelectionListener` interface.
`void` `addVerifyListener(VerifyListener listener)` Adds the listener to the collection of listeners who will be notified when the receiver's text is verified, by sending it one of the messages defined in the `VerifyListener` interface.
`void` `clearSelection()` Sets the selection in the receiver's text field to an empty selection starting just before the first character.
`Point` `computeSize(int wHint, int hHint, boolean changed)` Returns the preferred size of the receiver.
`void` `deselect(int index)` Deselects the item at the given zero-relative index in the receiver's list.
`void` `deselectAll()` Deselects all selected items in the receiver's list.
`Control[]` `getChildren()` Returns a (possibly empty) array containing the receiver's children.
`boolean` `getEditable()` Gets the editable state.
`java.lang.String` `getItem(int index)` Returns the item at the given, zero-relative index in the receiver's list.
`int` `getItemCount()` Returns the number of items contained in the receiver's list.
`int` `getItemHeight()` Returns the height of the area which would be used to display one of the items in the receiver's list.
`java.lang.String[]` `getItems()` Returns an array of `String`s which are the items in the receiver's list.
`boolean` `getListVisible()` Returns `true` if the receiver's list is visible, and `false` otherwise.
`Point` `getSelection()` Returns a `Point` whose x coordinate is the start of the selection in the receiver's text field, and whose y coordinate is the end of the selection.
`int` `getSelectionIndex()` Returns the zero-relative index of the item which is currently selected in the receiver's list, or -1 if no item is selected.
`int` `getStyle()` Returns the receiver's style information.
`java.lang.String` `getText()` Returns a string containing a copy of the contents of the receiver's text field.
`int` `getTextHeight()` Returns the height of the receivers's text field.
`int` `getTextLimit()` Returns the maximum number of characters that the receiver's text field is capable of holding.
`int` `getVisibleItemCount()` Gets the number of items that are visible in the drop down portion of the receiver's list.
`int` `indexOf(java.lang.String string)` Searches the receiver's list starting at the first item (index 0) until an item is found that is equal to the argument, and returns the index of that item.
`int` `indexOf(java.lang.String string, int start)` Searches the receiver's list starting at the given, zero-relative index until an item is found that is equal to the argument, and returns the index of that item.
`void` `remove(int index)` Removes the item from the receiver's list at the given zero-relative index.
`void` `remove(int start, int end)` Removes the items from the receiver's list which are between the given zero-relative start and end indices (inclusive).
`void` `remove(java.lang.String string)` Searches the receiver's list starting at the first item until an item is found that is equal to the argument, and removes that item from the list.
`void` `removeAll()` Removes all of the items from the receiver's list and clear the contents of receiver's text field.
`void` `removeModifyListener(ModifyListener listener)` Removes the listener from the collection of listeners who will be notified when the receiver's text is modified.
`void` `removeSelectionListener(SelectionListener listener)` Removes the listener from the collection of listeners who will be notified when the user changes the receiver's selection.
`void` `removeVerifyListener(VerifyListener listener)` Removes the listener from the collection of listeners who will be notified when the control is verified.
`void` `select(int index)` Selects the item at the given zero-relative index in the receiver's list.
`void` `setEditable(boolean editable)` Sets the editable state.
`void` `setItem(int index, java.lang.String string)` Sets the text of the item in the receiver's list at the given zero-relative index to the string argument.
`void` `setItems(java.lang.String[] items)` Sets the receiver's list to be the given array of items.
`void` `setLayout(Layout layout)` Sets the layout which is associated with the receiver to be the argument which may be null.
`void` `setListVisible(boolean visible)` Marks the receiver's list as visible if the argument is `true`, and marks it invisible otherwise.
`void` `setSelection(Point selection)` Sets the selection in the receiver's text field to the range specified by the argument whose x coordinate is the start of the selection and whose y coordinate is the end of the selection.
`void` `setText(java.lang.String string)` Sets the contents of the receiver's text field to the given string.
`void` `setTextLimit(int limit)` Sets the maximum number of characters that the receiver's text field is capable of holding to be the argument.
`void` `setVisibleItemCount(int count)` Sets the number of items that are visible in the drop down portion of the receiver's list.

Methods inherited from class org.eclipse.swt.widgets.Composite
`changed, getAdapter, getBackgroundMode, getLayout, getLayoutDeferred, getTabList, isLayoutDeferred, layout, layout, layout, layout, layout, setBackgroundMode, setFocus, setLayoutDeferred, setTabList`

Methods inherited from class org.eclipse.swt.widgets.Scrollable
`computeTrim, getClientArea, getHorizontalBar, getVerticalBar`

Methods inherited from class org.eclipse.swt.widgets.Control

`addControlListener, addDragDetectListener, addFocusListener, addGestureListener, addHelpListener, addKeyListener, addMenuDetectListener, addMouseListener, addTouchListener, addTraverseListener, computeSize, forceFocus, getAccessible, getBackground, getBackgroundImage, getBorderWidth, getBounds, getCursor, getEnabled, getFont, getForeground, getLayoutData, getLocation, getMenu, getMonitor, getOrientation, getParent, getShell, getSize, getToolTipText, getTouchEnabled, getVisible, isEnabled, isFocusControl, isReparentable, isVisible, moveAbove, moveBelow, pack, pack, redraw, redraw, removeControlListener, removeDragDetectListener, removeFocusListener, removeGestureListener, removeHelpListener, removeKeyListener, removeMenuDetectListener, removeMouseListener, removeTouchListener, removeTraverseListener, setBackground, setBackgroundImage, setBounds, setBounds, setCursor, setEnabled, setFont, setForeground, setLayoutData, setLocation, setLocation, setMenu, setOrientation, setParent, setRedraw, setSize, setSize, setToolTipText, setTouchEnabled, setVisible, toControl, toControl, toDisplay, toDisplay, update`

Methods inherited from class org.eclipse.swt.widgets.Widget
`addDisposeListener, addListener, checkSubclass, checkWidget, dispose, getData, getData, getDisplay, getListeners, isDisposed, isListening, notifyListeners, removeDisposeListener, removeListener, reskin, setData, setData, toString`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### LIMIT

    public static final int LIMIT

  The maximum number of characters that can be entered into a text widget.

  Note that this value is platform dependent, based upon the native widget implementation.

  See Also:
    Constant Field Values

Constructor Detail

### CCombo

    public CCombo(Composite parent,
                  int style)

  Constructs a new instance of this class given its parent and a style value describing its behavior and appearance.

  The style value is either one of the style constants defined in class `SWT` which is applicable to instances of this class, or must be built by bitwise OR'ing together (that is, using the `int` "|" operator) two or more of those `SWT` style constants. The class description lists the style constants that are applicable to the class. Style bits are also inherited from superclasses.

  Parameters:
    `parent` - a widget which will be the parent of the new instance (cannot be null)
    `style` - the style of widget to construct
  Throws:
    `java.lang.IllegalArgumentException` -
    - ERROR_NULL_ARGUMENT - if the parent is null
    `SWTException` -
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the parent
  See Also:
    `SWT.BORDER`, `SWT.READ_ONLY`, `SWT.FLAT`, `Widget.getStyle()`

Method Detail

### getStyle

    public int getStyle()

  Description copied from class: `Widget`
  Returns the receiver's style information.

  Note that the value which is returned by this method may not match the value which was provided to the constructor when the receiver was created. This can occur when the underlying operating system does not support a particular combination of requested styles. For example, if the platform widget used to implement a particular SWT widget always has scroll bars, the result of calling this method would always have the `SWT.H_SCROLL` and `SWT.V_SCROLL` bits set.

  Overrides:
    `getStyle` in class `Widget`
  Returns:
    the style bits

### getSelectionIndex

    public int getSelectionIndex()

  Returns the zero-relative index of the item which is currently selected in the receiver's list, or -1 if no item is selected.

  Returns:
    the index of the selected item
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### select

    public void select(int index)

  Selects the item at the given zero-relative index in the receiver's list. If the item at the index was already selected, it remains selected. Indices that are out of range are ignored.

  Parameters:
    `index` - the index of the item to select
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### deselect

    public void deselect(int index)

  Deselects the item at the given zero-relative index in the receiver's list. If the item at the index was already deselected, it remains deselected. Indices that are out of range are ignored.

  Parameters:
    `index` - the index of the item to deselect
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### deselectAll

    public void deselectAll()

  Deselects all selected items in the receiver's list.

  Note: To clear the selection in the receiver's text field, use `clearSelection()`.

  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
  See Also:
    `clearSelection()`

### setSelection

    public void setSelection(Point selection)

  Sets the selection in the receiver's text field to the range specified by the argument whose x coordinate is the start of the selection and whose y coordinate is the end of the selection.

  Parameters:
    `selection` - a point representing the new selection start and end
  Throws:
    `java.lang.IllegalArgumentException` -
    - ERROR_NULL_ARGUMENT - if the point is null
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### getSelection

    public Point getSelection()

  Returns a `Point` whose x coordinate is the start of the selection in the receiver's text field, and whose y coordinate is the end of the selection. The returned values are zero-relative. An "empty" selection as indicated by the the x and y coordinates having the same value.

  Returns:
    a point representing the selection start and end
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### setTextLimit

    public void setTextLimit(int limit)

  Sets the maximum number of characters that the receiver's text field is capable of holding to be the argument.

  Parameters:
    `limit` - new text limit
  Throws:
    `java.lang.IllegalArgumentException` -
    - ERROR_CANNOT_BE_ZERO - if the limit is zero
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### getTextLimit

    public int getTextLimit()

  Returns the maximum number of characters that the receiver's text field is capable of holding. If this has not been changed by `setTextLimit()`, it will be the constant `Combo.LIMIT`.

  Returns:
    the text limit
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### getTextHeight

    public int getTextHeight()

  Returns the height of the receivers's text field.

  Returns:
    the text height
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
  Since:
    1.3

### clearSelection

    public void clearSelection()

  Sets the selection in the receiver's text field to an empty selection starting just before the first character. If the text field is editable, this has the effect of placing the i-beam at the start of the text.

  Note: To clear the selected items in the receiver's list, use `deselectAll()`.

  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
  See Also:
    `deselectAll()`

### add

    public void add(java.lang.String string)

  Adds the argument to the end of the receiver's list.

  Parameters:
    `string` - the new item
  Throws:
    `java.lang.IllegalArgumentException` -
    - ERROR_NULL_ARGUMENT - if the string is null
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
  See Also:
    `add(String,int)`

### add

    public void add(java.lang.String string,
                    int index)

  Adds the argument to the receiver's list at the given zero-relative index.

  Note: To add an item at the end of the list, use the result of calling `getItemCount()` as the index or use `add(String)`.

  Parameters:
    `string` - the new item
    `index` - the index for the item
  Throws:
    `java.lang.IllegalArgumentException` -
    - ERROR_NULL_ARGUMENT - if the string is null
    - ERROR_INVALID_RANGE - if the index is not between 0 and the number of elements in the list (inclusive)
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
  See Also:
    `add(String)`

### remove

    public void remove(int index)

  Removes the item from the receiver's list at the given zero-relative index.

  Parameters:
    `index` - the index for the item
  Throws:
    `java.lang.IllegalArgumentException` -
    - ERROR_INVALID_RANGE - if the index is not between 0 and the number of elements in the list minus 1 (inclusive)
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### remove

    public void remove(int start,
                       int end)

  Removes the items from the receiver's list which are between the given zero-relative start and end indices (inclusive).

  Parameters:
    `start` - the start of the range
    `end` - the end of the range
  Throws:
    `java.lang.IllegalArgumentException` -
    - ERROR_INVALID_RANGE - if either the start or end are not between 0 and the number of elements in the list minus 1 (inclusive)
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### remove

    public void remove(java.lang.String string)

  Searches the receiver's list starting at the first item until an item is found that is equal to the argument, and removes that item from the list.

  Parameters:
    `string` - the item to remove
  Throws:
    `java.lang.IllegalArgumentException` -
    - ERROR_NULL_ARGUMENT - if the string is null
    - ERROR_INVALID_ARGUMENT - if the string is not found in the list
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### removeAll

    public void removeAll()

  Removes all of the items from the receiver's list and clear the contents of receiver's text field.

  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### setItem

    public void setItem(int index,
                        java.lang.String string)

  Sets the text of the item in the receiver's list at the given zero-relative index to the string argument. This is equivalent to `remove`'ing the old item at the index, and then `add`'ing the new item at that index.

  Parameters:
    `index` - the index for the item
    `string` - the new text for the item
  Throws:
    `java.lang.IllegalArgumentException` -
    - ERROR_INVALID_RANGE - if the index is not between 0 and the number of elements in the list minus 1 (inclusive)
    - ERROR_NULL_ARGUMENT - if the string is null
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### setItems

    public void setItems(java.lang.String[] items)

  Sets the receiver's list to be the given array of items.

  Parameters:
    `items` - the array of items
  Throws:
    `java.lang.IllegalArgumentException` -
    - ERROR_NULL_ARGUMENT - if the items array is null
    - ERROR_INVALID_ARGUMENT - if an item in the items array is null
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### getItem

    public java.lang.String getItem(int index)

  Returns the item at the given, zero-relative index in the receiver's list. Throws an exception if the index is out of range.

  Parameters:
    `index` - the index of the item to return
  Returns:
    the item at the given index
  Throws:
    `java.lang.IllegalArgumentException` -
    - ERROR_INVALID_RANGE - if the index is not between 0 and the number of elements in the list minus 1 (inclusive)
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### getItemCount

    public int getItemCount()

  Returns the number of items contained in the receiver's list.

  Returns:
    the number of items
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### getItemHeight

    public int getItemHeight()

  Returns the height of the area which would be used to display one of the items in the receiver's list.

  Returns:
    the height of one item
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### getItems

    public java.lang.String[] getItems()

  Returns an array of `String`s which are the items in the receiver's list.

  Note: This is not the actual structure used by the receiver to maintain its list of items, so modifying the array will not affect the receiver.

  Returns:
    the items in the receiver's list
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### setVisibleItemCount

    public void setVisibleItemCount(int count)

  Sets the number of items that are visible in the drop down portion of the receiver's list.

  Parameters:
    `count` - the new number of items to be visible
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### getVisibleItemCount

    public int getVisibleItemCount()

  Gets the number of items that are visible in the drop down portion of the receiver's list.

  Returns:
    the number of items that are visible
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### setListVisible

    public void setListVisible(boolean visible)

  Marks the receiver's list as visible if the argument is `true`, and marks it invisible otherwise.

  If one of the receiver's ancestors is not visible or some other condition makes the receiver not visible, marking it visible may not actually cause it to be displayed.

  Parameters:
    `visible` - the new visibility state
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### getListVisible

    public boolean getListVisible()

  Returns `true` if the receiver's list is visible, and `false` otherwise.

  If one of the receiver's ancestors is not visible or some other condition makes the receiver not visible, this method may still indicate that it is considered visible even though it may not actually be showing.

  Returns:
    the receiver's list's visibility state
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### indexOf

    public int indexOf(java.lang.String string)

  Searches the receiver's list starting at the first item (index 0) until an item is found that is equal to the argument, and returns the index of that item. If no item is found, returns -1.

  Parameters:
    `string` - the search item
  Returns:
    the index of the item
  Throws:
    `java.lang.IllegalArgumentException` -
    - ERROR_NULL_ARGUMENT - if the string is null
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### indexOf

    public int indexOf(java.lang.String string,
                       int start)

  Searches the receiver's list starting at the given, zero-relative index until an item is found that is equal to the argument, and returns the index of that item. If no item is found or the starting index is out of range, returns -1.

  Parameters:
    `string` - the search item
    `start` - the zero-relative index at which to begin the search
  Returns:
    the index of the item
  Throws:
    `java.lang.IllegalArgumentException` -
    - ERROR_NULL_ARGUMENT - if the string is null
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### setText

    public void setText(java.lang.String string)

  Sets the contents of the receiver's text field to the given string.

  Note: The text field in a `Combo` is typically only capable of displaying a single line of text. Thus, setting the text to a string containing line breaks or other special characters will probably cause it to display incorrectly.

  Parameters:
    `string` - the new text
  Throws:
    `java.lang.IllegalArgumentException` -
    - ERROR_NULL_ARGUMENT - if the string is null
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### getText

    public java.lang.String getText()

  Returns a string containing a copy of the contents of the receiver's text field.

  Returns:
    the receiver's text
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### setEditable

    public void setEditable(boolean editable)

  Sets the editable state.

  Parameters:
    `editable` - the new editable state
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### getEditable

    public boolean getEditable()

  Gets the editable state.

  Returns:
    whether or not the receiver is editable
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### computeSize

    public Point computeSize(int wHint,
                             int hHint,
                             boolean changed)

  Description copied from class: `Control`
  Returns the preferred size of the receiver.

  The preferred size of a control is the size that it would best be displayed at. The width hint and height hint arguments allow the caller to ask a control questions such as "Given a particular width, how high does the control need to be to show all of the contents?" To indicate that the caller does not wish to constrain a particular dimension, the constant `SWT.DEFAULT` is passed for the hint.

  If the changed flag is `true`, it indicates that the receiver's contents have changed, therefore any caches that a layout manager containing the control may have been keeping need to be flushed. When the control is resized, the changed flag will be `false`, so layout manager caches can be retained.

  Overrides:
    `computeSize` in class `Composite`
  Parameters:
    `wHint` - the width hint (can be `SWT.DEFAULT`)
    `hHint` - the height hint (can be `SWT.DEFAULT`)
    `changed` - `true` if the control's contents have changed, and `false` otherwise
  Returns:
    the preferred size of the control.
  See Also:
    `Layout`, `Control.getBorderWidth()`, `Control.getBounds()`, `Control.getSize()`, `Control.pack(boolean)`, "computeTrim, getClientArea for controls that implement them"

### addSelectionListener

    public void addSelectionListener(SelectionListener listener)

  Adds the listener to the collection of listeners who will be notified when the user changes the receiver's selection, by sending it one of the messages defined in the `SelectionListener` interface.

  `widgetSelected` is called when the combo's list selection changes. `widgetDefaultSelected` is typically called when ENTER is pressed the combo's text area.

  Parameters:
    `listener` - the listener which should be notified when the user changes the receiver's selection
  Throws:
    `java.lang.IllegalArgumentException` -
    - ERROR_NULL_ARGUMENT - if the listener is null
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
  See Also:
    `SelectionListener`, `removeSelectionListener(org.eclipse.swt.events.SelectionListener)`, `SelectionEvent`

### removeSelectionListener

    public void removeSelectionListener(SelectionListener listener)

  Removes the listener from the collection of listeners who will be notified when the user changes the receiver's selection.

  Parameters:
    `listener` - the listener which should no longer be notified
  Throws:
    `java.lang.IllegalArgumentException` -
    - ERROR_NULL_ARGUMENT - if the listener is null
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
  See Also:
    `SelectionListener`, `addSelectionListener(org.eclipse.swt.events.SelectionListener)`

### addModifyListener

    public void addModifyListener(ModifyListener listener)

  Adds the listener to the collection of listeners who will be notified when the receiver's text is modified, by sending it one of the messages defined in the `ModifyListener` interface.

  Parameters:
    `listener` - the listener which should be notified
  Throws:
    `java.lang.IllegalArgumentException` -
    - ERROR_NULL_ARGUMENT - if the listener is null
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
  See Also:
    `ModifyListener`, `removeModifyListener(org.eclipse.swt.events.ModifyListener)`

### removeModifyListener

    public void removeModifyListener(ModifyListener listener)

  Removes the listener from the collection of listeners who will be notified when the receiver's text is modified.

  Parameters:
    `listener` - the listener which should no longer be notified
  Throws:
    `java.lang.IllegalArgumentException` -
    - ERROR_NULL_ARGUMENT - if the listener is null
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
  See Also:
    `ModifyListener`, `addModifyListener(org.eclipse.swt.events.ModifyListener)`

### addVerifyListener

    public void addVerifyListener(VerifyListener listener)

  Adds the listener to the collection of listeners who will be notified when the receiver's text is verified, by sending it one of the messages defined in the `VerifyListener` interface.

  Parameters:
    `listener` - the listener which should be notified
  Throws:
    `java.lang.IllegalArgumentException` -
    - ERROR_NULL_ARGUMENT - if the listener is null
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
  See Also:
    `VerifyListener`, `removeVerifyListener(org.eclipse.swt.events.VerifyListener)`

### removeVerifyListener

    public void removeVerifyListener(VerifyListener listener)

  Removes the listener from the collection of listeners who will be notified when the control is verified.

  Parameters:
    `listener` - the listener which should no longer be notified
  Throws:
    `java.lang.IllegalArgumentException` -
    - ERROR_NULL_ARGUMENT - if the listener is null
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
  See Also:
    `VerifyListener`, `addVerifyListener(org.eclipse.swt.events.VerifyListener)`

### getChildren

    public Control[] getChildren()

  Description copied from class: `Composite`
  Returns a (possibly empty) array containing the receiver's children. Children are returned in the order that they are drawn. The topmost control appears at the beginning of the array. Subsequent controls draw beneath this control and appear later in the array.

  Note: This is not the actual structure used by the receiver to maintain its list of children, so modifying the array will not affect the receiver.

  Overrides:
    `getChildren` in class `Composite`
  Returns:
    an array of children
  See Also:
    `Control.moveAbove(org.eclipse.swt.widgets.Control)`, `Control.moveBelow(org.eclipse.swt.widgets.Control)`

### setLayout

    public void setLayout(Layout layout)

  Sets the layout which is associated with the receiver to be the argument which may be null.

  Note: No Layout can be set on this Control because it already manages the size and position of its children.

  Overrides:
    `setLayout` in class `Composite`
  Parameters:
    `layout` - the receiver's new layout or null
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

Eclipse Remote Application Platform

Copyright (c) EclipseSource and others 2002, 2014. All rights reserved. This program and the accompanying materials are made available under the terms of the Eclipse Public License v1.0